PROC GLOBAL

file listingFile,directoryListing,outputReport;

alpha (5000) str;
alpha (200) basePath,listingFilename;

numeric	MAX_FILES = 100,
		MAX_MESSAGES = 300;

array errorNumbers(MAX_MESSAGES);
array alpha(200) errorMessages(MAX_MESSAGES);
array errorPercents(MAX_FILES,MAX_MESSAGES);
array alpha(200) errorFilenames(MAX_FILES);

numeric fileNum;

function returnLengthErrorMessage(alpha(200) message)

	numeric len = length(strip(message));
	
	while message[len:1] in "0":"9" do
		inc(len,-1);
	enddo;
	
	while message[len:1] in " " do
		inc(len,-1);
	enddo;
	
	returnLengthErrorMessage = len;

end;


PROC LISTINGREPORTSUMMARIES_FF

preproc

	fileread(directoryListing,basePath);
	
	while fileread(directoryListing,listingFilename) do
	
		if setfile(listingFile,concat(strip(basePath),strip(listingFilename))) then
		
			inc(fileNum);
			errorFilenames(fileNum) = listingFilename;
		
			while fileread(listingFile,str) and str <> "User numbered messages:" do
			enddo;
			
			numeric messageNum;

			while fileread(listingFile,str) and str <> "CSPRO Executor Normal End" do
			
				if not tonumber(str[1:7]) in 0,default then // we have a valid error message

					inc(messageNum);
					errorPercents(fileNum,messageNum) = tonumber(str[17:5]);

					if fileNum = 1 then
						errorNumbers(messageNum) = tonumber(str[1:7]);
						errorMessages(messageNum) = str[24];
					endif;
					
				endif;
			
			enddo;
		
			close(listingFile);
		
		else
			errmsg("Could not open listing file: %s",listingFilename);
		
		endif;
		
	enddo;
	
	// print out the report
	numeric i,j;
	
	str = "Message Number,Message";
	
	do i = 1 while i <= fileNum
		str = maketext("%s,%s",strip(str),errorFilenames(i)[1:length(strip(errorFilenames(i))) - 4]); // remove the .lst
	enddo;
	
	filewrite(outputReport,"%s",strip(str));
	
	do i = 1 while i <= messageNum
	
		str = maketext('%d,"%s"',errorNumbers(i),errorMessages(i)[1:returnLengthErrorMessage(errorMessages(i))]);

		do j = 1 while j <= fileNum
			str = maketext("%s,%f",strip(str),errorPercents(j,i));		
		enddo;
		
		filewrite(outputReport,"%s",strip(str));
			
	enddo;
	
	
